using Microsoft.Extensions.Logging;

namespace File_Folder_Helper.ADO2024.PI2;

internal static partial class Helper20240510
{

    internal static void PullIconsForBLM(ILogger<Worker> logger, List<string> args)
    {
        string fileName;
        FileInfo fileInfo;
        string searchPattern = args[4];
        string sourceDirectory = args[3];
        string root = Path.GetFullPath(args[0]);
        string createDirectory = Path.Combine(root, args[2]);
        if (!Directory.Exists(createDirectory))
            _ = Directory.CreateDirectory(createDirectory);
        string[] files = Directory.GetFiles(sourceDirectory, searchPattern, SearchOption.TopDirectoryOnly);
        foreach (string file in files)
        {
            fileName = Path.GetFileName(file);
            fileInfo = new(Path.Combine(createDirectory, fileName));
            if (fileInfo.Exists && fileInfo.LastWriteTime == new FileInfo(file).LastWriteTime)
                continue;
            File.Copy(file, fileInfo.FullName, overwrite: true);
            logger.LogInformation("<{fileName}> copied", fileName);
        }
        logger.LogWarning("What reactor is this near?");
        string? reactor = Console.ReadLine();
        if (!string.IsNullOrEmpty(reactor))
            _ = Directory.CreateDirectory(Path.Combine(sourceDirectory, Environment.MachineName, reactor));
    }

}