using Microsoft.Extensions.Logging;
using System.Text;

namespace File_Folder_Helper.ADO2024.PI4;

internal static partial class Helper20241204
{

    internal static void ConvertToUTF8(ILogger<Worker> logger, List<string> args)
    {
        string text;
        string searchPattern = args[2];
        string sourceDirectory = Path.GetFullPath(args[0]);
        string[] files = Directory.GetFiles(sourceDirectory, searchPattern, SearchOption.TopDirectoryOnly);
        if (files.Length == 0)
            logger.LogError("No files found in {sourceDirectory} with search pattern {searchPattern}", sourceDirectory, searchPattern);
        foreach (string file in files)
        {
            text = File.ReadAllText(file);
            File.WriteAllText(file, text, Encoding.UTF8);
        }
    }

}