using System.Collections.ObjectModel;
using System.Text.Json.Serialization;

namespace File_Folder_Helper.Models;

internal record H2NoCheckboxes(string H2,
                              ReadOnlyCollection<string> Lines);

[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.WhenWritingNull)]
[JsonSerializable(typeof(H2NoCheckboxes))]
internal partial class H2NoCheckboxesSourceGenerationContext : JsonSerializerContext
{
}